      PROGRAM GENFTBL
C
C   Last modified May 25, 1995 -- RSR
C   modified July 19, 1993 -- RSR
C   modified March 1, 1993 -- RSR
C
C  THIS IS AN INTERACTIVE PROGRAM THAT PROMPTS FOR ALL
C  INFORMATION REQUIRED FOR AN EXECUTION.
C
C  VARIABLE DECLARATIONS
C
      INCLUDE 'ftable.inc'
C
      INTEGER i, irchnm, itmplt, j, knt, numxs, istngr(MXXSPR), k, mxnxs
      CHARACTER msg1*64, versn*72
      LOGICAL yes
C
      versn = 
     &   '@(#)GENFTBL - Postprocessor for CGAP to produce HSPF F-TABLES'
      versn = '@(#)GENFTBL - Contact: h2osoft@usgs.gov'
C---this string (characters 5-40) is used for labeling printouts.
      versn = '@(#)GENFTBL - Version: 3.1x 1995/05/26'
      msg1 = 
     & '$Id: genftbl.f,v 2.5 1995/05/26 14:47:35 rsregan Exp rsregan $'
      versn = 'GENFTBL - Version: '//msg1(18:31)
C
      CALL FTBIOF(versn(:33))
      knt = 0
   10 knt = knt + 1
      IF (knt.GT.MAXS+1) THEN
        WRITE (*,9030) MAXS
        GOTO 40
      ELSE
        READ (IRDR,9015,END=40,ERR=30)
        READ (IRDR,9005,END=40,ERR=30) Ixsnum(knt), Ixsknt(knt), 
     &                                 Ixsdis(knt)
        READ (IRDR,9015,END=40,ERR=30)
        DO 20 i = 1, Ixsknt(knt)
          READ (IRDR,9010,END=40,ERR=30) Stage(i,knt), Dischr(i,knt), 
     &          Area(i,knt), Width(i,knt)
   20   CONTINUE
        GOTO 10
      ENDIF
   30 STOP '**Error reading input'
C
C---finished reading input
   40 knt = knt - 1
      IF (Ixsdis(1).EQ.0) THEN
        DO 50 i = 3, knt
          Ixsdis(i) = Ixsdis(i) + Ixsdis(i-1)
   50   CONTINUE
      ENDIF
      mxnxs = MIN0(knt,MXXSPR)
      irchnm = 100
   60 msg1 = 'THE REACH NUMBER (0-99999)'
      CALL GETIVL(msg1,0,99999,irchnm)
      WRITE (msg1,'(A,I3,A1)') 'NUMBER OF CROSS SECTIONS IN REACH (1-', 
     &                         mxnxs, ')'
      numxs = mxnxs
      CALL GETIVL(msg1,1,mxnxs,numxs)
      WRITE (*,9020)
      WRITE (*,'(10I6)') (Ixsnum(i),i=1,knt)
      istngr(1) = Ixsnum(1)
      DO 90 i = 1, numxs
   70   IF (i.GT.1) istngr(i) = istngr(i-1) + 1
        WRITE (msg1,'(a,i4,a)') 'CROSS SECTION NUMBER', i, ' IN REACH'
        CALL GETIVL(msg1,0,99,istngr(i))
        DO 80 j = 1, knt
          IF (Ixsnum(j).EQ.istngr(i)) THEN
            Indx(i) = j
            GOTO 90
          ENDIF
   80   CONTINUE
        WRITE (*,9035)
        WRITE (*,9020)
        WRITE (*,'(10I6)') (Ixsnum(k),k=1,knt)
        GOTO 70
   90 CONTINUE
      WRITE (*,9025)
      itmplt = istngr(1)
      msg1 = 'CROSS SECTION NUMBER OF TEMPLATE'
      CALL GETIVL(msg1,0,99,itmplt)
C     create outputs
      CALL MKTBL1(itmplt,numxs)
      CALL MKFTBL(irchnm,numxs)
      msg1 = 'DO YOU WANT TO COMPUTE A TABLE FOR ANOTHER REACH'
      CALL GETYES(msg1,yes)
      IF (yes) GOTO 60
      STOP
C
 9005 FORMAT (14X,I4,9X,I4,11X,I8)
 9010 FORMAT (F10.2,3(F11.0))
 9015 FORMAT (1X)
 9020 FORMAT (/,
     &' Cross sections should be specified in upstream order.  The cross
     & section',/,
     & ' numbers available, given in order of input from the CGAP output 
     & file, are:',/,10I6)
 9025 FORMAT (/,
     &' Template cross section is used to designate those stages and dis
     &charges',/,' at which properties are determined for the other cros
     &s sections in reach.',/,' This should normally be the outlet cross
     & section.')
 9030 FORMAT (/,' **Warning, exceeded maximum number of cross sections',
     &        I5,/,
     &' Increase MAXS in FTABLE.INC file.  Excess cross sections were no
     &t read.')
 9035 FORMAT (/,' Invalid cross section number entered')
      END
C
      SUBROUTINE FTBIOF(VERSN)
C  Last modified MAY 25, 1995 -- RSR
C
      CHARACTER*33 VERSN
      CHARACTER*48 datnam, prname, tblnam, blank
      CHARACTER msg*80, fdesc(4)*24
      CHARACTER*12 mtrfil
      INCLUDE 'ftable.inc'
      LOGICAL okflag, outfil, yes
      INTEGER len, lenp1, lenp4, i, retc
      DATA mtrfil/'GENFTBL.MTR '/, 
     &     blank/'                                                '/, 
     &     fdesc/'Input data (CGAP output) :', 
     &     'Printer output           :', 'Peliminary output        :', 
     &     'F-Table output           :'/
      len = 48
      datnam = 'cgap.pun '
      prname = 'genftbl.log '
      tblnam = 'genftbl.tbl '
      okflag = .FALSE.
      outfil = .FALSE.
      WRITE (*,9005) VERSN
C
C---CHECK STATUS OF CGAP MASTER FILE
      CALL OPNRDR(MASTR,mtrfil,1,retc)
      IF (retc.LT.0) GOTO 40
      WRITE (*,9010)
      IF (retc.EQ.0) THEN
        DO 10 i = 1, 3
          READ (MASTR,'(A80)',END=20) msg
   10   CONTINUE
        REWIND MASTR
        READ (MASTR,'(26X,A48)') datnam
        READ (MASTR,'(26X,A48)') prname
        READ (MASTR,'(26X,A48)') tblnam
        REWIND MASTR
      ENDIF
      GOTO 30
C---End of file encountered reading master file
   20 REWIND MASTR
      WRITE (*,9020)
C
   30 WRITE (*,'(1X,A,1X,A)') fdesc(1), datnam
      WRITE (*,'(1X,A,1X,A)') fdesc(2), prname
      WRITE (*,'(1X,A,1X,A)') fdesc(4), tblnam
      WRITE (*,9015)
      msg = 'ARE THESE THE REQUIRED FILES FOR THIS EXECUTION'
      CALL GETYES(msg,yes)
      IF (yes) okflag = .TRUE.
C
C---IF MASTER FILE NAMES ARE CORRECT USE THEM, OTHERWISE PROMPT USER
      IF (datnam.EQ.blank) datnam = 'cgap.pun '
      IF (.NOT.okflag) THEN
        msg = 'ENTER THE INPUT DATA FILE NAME (OUTPUT FROM CGAP)'
        CALL IOPRMP(msg,datnam)
      ENDIF
      CALL OPNRDR(IRDR,datnam,0,retc)
      IF (retc.EQ.0) THEN
        IF (.NOT.okflag) THEN
          msg = 'GENERATE OUTPUT FILE NAMES USING INPUT DATA FILE NAME'
          CALL GETYES(msg,yes)
          IF (yes) outfil = .TRUE.
        ENDIF
        CALL FILPRE(datnam,len)
        lenp1 = len + 1
        lenp4 = len + 4
C
C---ASSIGN THE PRINTED OUTPUT FILE NAME AND OPEN
        IF (prname.EQ.blank .OR. outfil) THEN
          prname(1:len) = datnam
          prname(lenp1:lenp4) = '.log'
          IF (okflag) WRITE (*,9030) 'Printed', prname
        ENDIF
        IF (.NOT.okflag .AND. .NOT.outfil) THEN
          msg = 'ENTER PRINTER OUTPUT FILE NAME'
          CALL IOPRMP(msg,prname)
        ENDIF
        CALL OPNFIL(IPRT,prname)
C
C---IF PLOTTER INSTRUCTIONS ARE TO BE OUTPUT, OPEN FILE
        IF (tblnam.EQ.blank .OR. outfil) THEN
          tblnam(1:len) = datnam
          tblnam(lenp1:lenp4) = '.ftb'
          IF (okflag) WRITE (*,9030) 'F-Table', tblnam
        ENDIF
        IF (.NOT.okflag .AND. .NOT.outfil) THEN
          msg = 'ENTER F-TABLE OUTPUT FILE NAME'
          CALL IOPRMP(msg,tblnam)
        ENDIF
        CALL OPNFIL(IOTBL,tblnam)
C
        WRITE (MASTR,9025) fdesc(1), datnam
        WRITE (MASTR,9025) fdesc(2), prname
        WRITE (MASTR,9025) fdesc(4), tblnam
        ENDFILE MASTR
        CLOSE (MASTR)
        RETURN
      ENDIF
   40 STOP '**Error** in ciofil, check access rights or file in use.'
 9005 FORMAT (////,15X,'Welcome to ',A,/,12X,
     &        '"A Computer Program to generate F-Tables for HSPF"',//,
     &' You may enter "Q" to any prompt to discontinue initiation of the
     & program.',/,
     &' If the displayed or default value following a prompt is acceptab
     &le, a',/,
     &' carriage return is sufficient response, otherwise a new value mu
     &st be',/,
     &' entered.  The default response to a "yes/no" query is yes.',/)
 9010 FORMAT (' These are the current file names assigned:',/)
 9015 FORMAT (/,' Note, all named output files will be deleted and(or) o
     &verwritten.',/)
 9020 FORMAT (/,1X,
     &      '*ERROR* End of file for master file, will create new file')
 9025 FORMAT (1X,A,1X,A)
 9030 FORMAT (' *WARNING* ',A,' output file unspecified.',/,
     &        ' *** Default file name assigned: ',A48,/)
      END
C-----------------------------------------------------------------------
C  Name:  MKTBL1
C  LAST MODIFIED MAY 25, 1995 -- RSR
C
C  Purpose:    Generate a table of stage/discharge/area/width relationships.
C
C  Usage:      CALL MKTBL1(ITMPLT,NUMXS)
C
C  Arguments:
C    ITMPLT -- The cross section number of the base cross section
C    NUMXS  -- The number of cross sections in the reach
C
C  Remarks:
C
C  Keywords:  minimum,maximum,value,integer,stop
C
C-----------------------------------------------------------------------
C
      SUBROUTINE MKTBL1(ITMPLT,NUMXS)
C                                  SPECIFICATIONS FOR ARGUMENT VARIABLES
      INTEGER ITMPLT, NUMXS
C
      INCLUDE 'ftable.inc'
C                                  SPECIFICATIONS FOR LOCAL VARIABLES
      REAL avea, avew, dist, pct, qk, qq, tota(MXTBLE), totw(MXTBLE), 
     &     aout(MXTBLE,MXXSPR), wout(MXTBLE,MXXSPR), dpct(MXXSPR), qd
      INTEGER j, k, l, n, ndx1, i, ndx, ndxtmp
C
C---load output arrays with data from template cross section
C---ndxtmp is the index number into the input arrays of the template XS
      DO 20 i = 1, NUMXS
        ndxtmp = Indx(i)
        IF (Ixsnum(ndxtmp).EQ.ITMPLT) THEN
          Nrows = Ixsknt(ndxtmp)
          IF (Nrows.GT.MXTBLE) GOTO 100
          DO 10 j = 1, Nrows
            Zout(j) = Stage(j,ndxtmp)
            Qout(j) = Dischr(j,ndxtmp)
            aout(j,i) = Area(j,ndxtmp)
            tota(j) = aout(j,i)
            wout(j,i) = Width(j,ndxtmp)
            totw(j) = wout(j,i)
   10     CONTINUE
          GOTO 30
        ENDIF
   20 CONTINUE
C
C---load output arrays with data from other cross sections
   30 DO 60 i = 1, NUMXS
        ndx = Indx(i)
        IF (ndx.NE.ndxtmp) THEN
          n = Ixsknt(ndx)
          IF (n.GT.MXTBLE) GOTO 100
          k = 2
          qk = Dischr(k,ndx)
          DO 50 j = 1, Nrows
            qq = Dischr(j,ndxtmp)
   40       IF (qq.GT.qk) THEN
              IF (k.EQ.n) THEN
                Nrows = j - 1
                WRITE (*,9020) i, qq, Dischr(1,ndxtmp), 
     &                         Dischr(Nrows,ndxtmp)
                GOTO 30
              ELSE
                k = k + 1
                qk = Dischr(k,ndx)
                GOTO 40
              ENDIF
            ENDIF
            IF (k.GT.n .OR. qq.LT.Dischr(k-1,ndx)) THEN
              aout(j,i) = 0.0
              wout(j,i) = 0.0
            ELSE
              qd = qk - Dischr(k-1,ndx)
              IF (qd.NE.0.0) THEN
                pct = (qk-qq)/qd
              ELSE
                pct = 0.0
              ENDIF
              aout(j,i) = Area(k,ndx) - pct*(Area(k,ndx)-Area(k-1,ndx))
              tota(j) = tota(j) + aout(j,i)
              wout(j,i) = Width(k,ndx)
     &                    - pct*(Width(k,ndx)-Width(k-1,ndx))
              totw(j) = totw(j) + wout(j,i)
            ENDIF
   50     CONTINUE
        ENDIF
   60 CONTINUE
C
C---compute distance percentages of reach to compute weighted average
C---multiple by 0.5 to use average of each pair
      dist = FLOAT(Ixsdis(Indx(NUMXS))-Ixsdis(Indx(1)))
      dist = ABS(dist)
      DO 70 i = 2, NUMXS
        ndx1 = Indx(i-1)
        ndx = Indx(i)
        dpct(i) = 0.5*ABS(FLOAT(Ixsdis(ndx)-Ixsdis(ndx1)))/dist
   70 CONTINUE
      WRITE (IPRT,9005) ('   area  ',i=1,NUMXS), ('  Width  ',j=1,NUMXS)
      WRITE (IPRT,9010) (i,i=1,NUMXS), (j,j=1,NUMXS)
C
C---compute averages and print table
      DO 90 j = 1, Nrows
        avea = tota(j)/NUMXS
        avew = totw(j)/NUMXS
        Wtavea(j) = 0.0
        Wtavew(j) = 0.0
        DO 80 i = 2, NUMXS
          ndx1 = Indx(i-1)
          ndx = Indx(i)
          Wtavea(j) = Wtavea(j) + dpct(i)*(aout(j,ndx)+aout(j,ndx1))
          Wtavew(j) = Wtavew(j) + dpct(i)*(wout(j,ndx)+wout(j,ndx1))
   80   CONTINUE
        WRITE (IPRT,9015) Zout(j), Qout(j), Wtavea(j), Wtavew(j), avea, 
     &                    avew, (aout(j,k),k=1,NUMXS), 
     &                    (wout(j,l),l=1,NUMXS)
   90 CONTINUE
C
      RETURN
  100 WRITE (*,9025) MXTBLE
      STOP
 9005 FORMAT (/,21X,'Weighted Weighted  Average  Average',20(A9))
 9010 FORMAT (4X,'Stage  Discharge   Area    Width     Area    Width',
     &        I8,20(I9))
 9015 FORMAT (F9.2,30F9.1)
 9020 FORMAT (/,
     &' **Warning, discharge range of template cross section exceeds ran
     &ge of',/,' cross section #',I3,' at discharge',F10.1,/,
     &' FTABLE range changed to:',F10.1,' -',F10.1)
 9025 FORMAT (/,
     &  ' **Error, exceeded maximum number of stage/discharge relations'
     &  ,I5,/,' increase MXTBLE in FTABLE.INC')
      END
C
C
C     SUBROUTINE MKFTBL
C
C
C     MKFTBL - ROUTINE TO FORMAT CROSS SECTION DATA IN HSPF
C              FTABLE FORMAT, ENGLISH UNITS
C
      SUBROUTINE MKFTBL(IRCHNM,NUMXS)
C
C     + + + ARGUMENT DEFINITIONS + + +
      INTEGER IRCHNM, NUMXS
C
C     + + + LOCAL VARIABLES + + +
      REAL dist, ft2acre, volume, sfarea
      INTEGER j
C
      INCLUDE 'ftable.inc'
C
C     LENGTH-FEET
C
      ft2acre = 1.0/43560.0
      dist = FLOAT(Ixsdis(Indx(NUMXS))-Ixsdis(Indx(1)))
      dist = ABS(dist)
      WRITE (IOTBL,9005) IRCHNM, Nrows
C
C---MAIN CHANNEL COMPUTATIONS
C
      DO 10 j = 1, Nrows
        volume = Wtavea(j)*ft2acre*dist
        sfarea = Wtavew(j)*ft2acre*dist
        WRITE (IOTBL,9010) Zout(j), sfarea, volume, Qout(j)
   10 CONTINUE
C
      WRITE (IOTBL,9015) IRCHNM
C
      RETURN
C
C     + + + WRITE FORMATS + + +
 9005 FORMAT ('  FTABLE    ',I3,/,' ROWS COLS ***',/,I5,'    4',/,
     &        '     DEPTH      AREA    VOLUME     DISCH ***',/,
     &        '      (FT)   (ACRES)   (AC-FT)     (CFS) ***')
 9010 FORMAT (3F10.3,F10.2)
 9015 FORMAT ('  END FTABLE',I3,/)
      END
