      SUBROUTINE IDINFO(CHARST,ILINE,ISET)
      INTEGER ILINE, ISET
      CHARACTER*1 CHARST(*)
C
C                             SUBROUTINE IDINFO
C
C    SUBROUTINE "IDINFO" IS A SERVICE SUBROUTINE WHICH CONTROLS
C  SUBROUTINE "CHARAC". ITS FUNCTION, WHEN GIVEN AN ARRAY OF CHARACTERS
C  TO BE PRINTED IN LARGE FORMAT (7 PRINTER-LINES HIGH), IS TO BREAK
C  THE ARRAY OF CHARACTERS DOWN INTO "LINES" OF 22 CHARACTERS EACH AND
C  PAGES HAVING 7 "LINES" OF PRINT PER PAGE.  WHEN 7 "LINES" OF TEXT OR
C  MORE ARE TO BE PRINTED, PRINTING BEGINS AT THE TOP OF A NEW PAGE.
C  WHEN PRINTING LESS THAN 7 "LINES", BE CERTAIN ADEQUATE SPACE FOR
C  PRINTING REMAINS ON THE CURRENT PAGE.
C
C    THE ARRAY CHARST IS AN CHARACTER, 1-BYTE ARRAY IN WHICH THE PRINT
C  CHARACTER IS STORED.  THE ARRAY MUST BE DIMENSIONED AT LEAST 22 TIMES
C  ILINE BY THE CALLING PROGRAM.
C
C                                VARIABLE LIST
C
C   ISET   -CHAR. FONT CHOSEN; 1 OR 2   K       -COUNTER; EACH TEXT LINE
C   ILINE  -NUMBER OF LINES OF TEXT     M       -COUNTER; ARRAY INCHAR
C   II     -LINE COUNTER                L       -COUNTER; ARRAY CHARST
C   MEMORY -PAGE CONTROL; SET BY ILINE  INCHAR  -LINE OF CHAR PASSED
C   I      -LINE CONTROL                CHARST  -CHAR. ARRAY PASSED
C   J      -TOTAL NO. OF CHAR IN TEXT
C
C     INCHAR IS THE ARRAY OF CHARACTERS TO BE PRINTED, CHARST(1) GIVES
C     THE FIRST POSITION OF THE TRANSFERRED ARRAY.
      INTEGER i, j, k, l, m, ii, memory
      CHARACTER*1 inchar(22)
      INCLUDE 'cgunit.cmn'
C
C---ERROR CONTROL
      IF (ILINE.EQ.0) GOTO 50
      ii = 1
      memory = ILINE
      IF (memory.GT.6) GOTO 40
C
C---IF LESS THAN 6 LINES MEMORY IS SET TO 0
      memory = 0
   10 DO 30 i = 1, ILINE
        j = ii*22
        k = j - 21
        m = 0
        ii = ii + 1
        DO 20 l = k, j
          m = m + 1
C
C---THE CHARACTER IN CHARST IS TRANSFERRED TO INCHAR.
          IF (CHARST(l).GE.'a' .AND. CHARST(l).LE.'z') CHARST(l)
     &        = CHAR(ICHAR(CHARST(l))-32)
          inchar(m) = CHARST(l)
   20   CONTINUE
C
C---ALL 22 CHARACTERS ARE TO BE PRINTED BY SUBROUTINE CHARAC.
        CALL CHARAC(inchar,ISET)
   30 CONTINUE
      IF (memory.EQ.0) GOTO 50
C     EJECT A PAGE
      IF (memory.LT.7) THEN
        WRITE (Iprt,9005)
        ILINE = memory
        memory = 0
        GOTO 10
      ENDIF
C
   40 WRITE (Iprt,9005)
C
C---SINCE THERE ARE 7 LINES PER PAGE, 7 IS SUBTRACTED FROM MEMORY.
      memory = memory - 7
      ILINE = 7
      GOTO 10
C
   50 RETURN
 9005 FORMAT ('1')
      END
C
      SUBROUTINE CHARAC(INCHAR,ISET)
      INTEGER ISET
      CHARACTER*1 INCHAR(*)
C
C                             SUBROUTINE CHARAC
C
C    SUBROUTINE "CHARAC" IS A SERVICE SUBROUTINE CALLED BY CONTROL
C  SUBROUTINE "IDINFO".  IT CONSISTS OF TWO LARGE ARRAYS, "CHAR" AND
C  "CKAR", COMPRISING INDIVIDUAL PRINT CHARACTERS USED IN PRINTING A
C  7 PRINT-LINE HIGH "LINE" OF TEXT INFORMATION.  ITS FUNCTION IS TO
C  SET UP THE PRINTING ARRAY "OUT" USING THE PROPER SYMBOL IN ORDER TO
C  CREATE THE DESIRED TEXT INFORMATION.
C
C                                VARIABLE LIST
C
C    II  -CHAR. COUNTER IN ARRAY               CHAR  -ARRAY OF 64 CHAR.
C    JJ  -HOLDS PREVIOUS CHARACTER             CHAR1 -SUB ARRAY OF CHAR
C    K   -CHAR. COUNTER, ARRAY CKAR OR CHAR    CHAR2 -SUB ARRAY OF CHAR
C    KK  -EQUAL K COUNTER -1                   CKAR  -ARRAY OF 64 CHAR
C    OUT -ARRAY OF CHAR. TO BE PRINTED         CKAR1 -SUB ARRAY OF CKAR
C                                              CKAR2 -SUB ARRAY OF CKAR
C
      CHARACTER*6 out(7,22)
      CHARACTER*6 char(7,64)
      CHARACTER*6 char1(7,23)
      CHARACTER*6 char2(7,18)
      CHARACTER*6 ckar(7,64)
      CHARACTER*6 ckar1(7,23)
      CHARACTER*6 ckar2(7,18)
      CHARACTER*1 ichar(64)
      INTEGER i, j, k, ii, kk
      INCLUDE 'cgunit.cmn'
      DATA char/7*'      ', '  00  ', 5*' 0  0 ', '  00  ', '  1   ', 
     &     ' 11   ', 4*'  1   ', ' 111  ', ' 222  ', '2   2 ', '    2 ', 
     &     ' 222  ', 2*'2     ', '22222 ', ' 333  ', '3   3 ', '    3 ', 
     &     '  33  ', '    3 ', '3   3 ', ' 333  ', '   4  ', '  44  ', 
     &     ' 4 4  ', '4  4  ', '44444 ', 2*'   4  ', '55555 ', '5     ', 
     &     '5555  ', 2*'    5 ', '5   5 ', ' 555  ', '  666 ', ' 6    ', 
     &     '6     ', '6666  ', 2*'6   6 ', ' 666  ', '77777 ', '    7 ', 
     &     '   7  ', '  7   ', 3*' 7    ', ' 888  ', 2*'8   8 ', 
     &     ' 888  ', 2*'8   8 ', ' 888  ', ' 999  ', 2*'9   9 ', 
     &     ' 9999 ', '    9 ', '   9  ', ' 99   ', '  A   ', ' A A  ', 
     &     2*'A   A ', 'AAAAA ', 2*'A   A ', 'BBBB  ', 2*' B  B ', 
     &     ' BBB  ', 2*' B  B ', 'BBBB  ', ' CCC  ', 'C   C ', 
     & 3*'C     ', 'C   C ', ' CCC  ', 'DDDD  ', 5*' D  D ', 'DDDD  ',
     & 'EEEEE ', 2*'E     ', 'EEE   ', 2*'E     ', 'EEEEE ', 'FFFFF ',
     & 2*'F     ', 'FFF   ', 3*'F     ', ' GGG  ', 'G   G ', 2*'G     ',
     & 'G GGG ', 'G   G ', ' GGG  ', 3*'H   H ', 'HHHHH ', 3*'H   H ',
     & ' III  ', 5*'  I   ', ' III  ', 5*'    J ', 'J   J ', ' JJJ  ',
     & 'K   K ', 'K  K  ', 'K K   ', 'KK    ', 'K K   ', 'K  K  ',
     & 'K   K ', 6*'L     ', 'LLLLL ', 287*'      '/
      DATA char1/'M   M ', 'MM MM ', 'M M M ', 4*'M   M ', 'N   N ', 
     &     'NN  N ', 'N N N ', 'N  NN ', 3*'N   N ', 'OOOOO ', 
     &     5*'O   O ', 'OOOOO ', 'PPPP  ', 2*'P   P ', 'PPPP  ', 
     &     3*'P     ', ' QQQ  ', 3*'Q   Q ', 'Q Q Q ', 'Q  Q  ', 
     &     ' QQ Q ', 'RRRR  ', 2*'R   R ', 'RRRR  ', 'R R   ', 'R  R  ', 
     &     'R   R ', ' SSS  ', 'S   S ', 'S     ', ' SSS  ', '    S ', 
     &     'S   S ', ' SSS  ', 'TTTTT ', 6*'  T   ', 6*'U   U ', 
     &     ' UUU  ', 5*'V   V ', ' V V  ', '  V   ', 4*'W   W ', 
     &     'W W W ', 'WW WW ', 'W   W ', 2*'X   X ', ' X X  ', '  X   ', 
     &     ' X X  ', 2*'X   X ', 2*'Y   Y ', ' Y Y  ', 4*'  Y   ', 
     &     'ZZZZZ ', '    Z ', '   Z  ', '  Z   ', ' Z    ', 'Z     ', 
     &     'ZZZZZ ', ' &&   ', 2*'&  &  ', ' &    ', '& & & ', '&  &  ', 
     &     ' && & ', '  !   ', ' CCCC ', 3*'C |   ', ' CCCC ', '  !   ', 
     &     5*'      ', 2*' ##   ', 4*'      ', 2*' ##   ', '  #   ', 
     &     '      ', 2*' ##   ', '      ', 2*' ##   ', '      ', 
     &     '    / ', '   // ', '  //  ', ' //   ', '//    ', '/     ', 
     &     '      ', '      ', 2*'  +   ', '+++++ ', 2*'  +   ', 
     &     '      ', 3*'      ', '===== ', 3*'      ', '  $   ', 
     &     ' $$$$ ', '$     ', ' $$$  ', '    $ ', '$$$$  ', '  $   '/
      DATA char2/2*'      ', '===== ', '      ', '===== ', 2*'      ', 
     &     '* * * ', ' ***  ', '***** ', ' ***  ', '* * * ', 2*'      ', 
     &     7*'  !|  ', 5*'  ##  ', '      ', '  ##  ', '      ', 
     &     2*' ##   ', '      ', 2*' ##   ', '  #   ', '  (   ', 
     &     ' (    ', 3*'(     ', ' (    ', '  (   ', '  )   ', '   )  ', 
     &     3*'    ) ', '   )  ', '  )   ', '   <  ', '  <   ', ' <    ', 
     &     '<     ', ' <    ', '  <   ', '   <  ', ' >    ', '  >   ', 
     &     '   >  ', '    > ', '   >  ', '  >   ', ' >    ', 2*'()  % ', 
     &     '   %  ', '  %   ', ' %    ', 2*'%  () ', ' ???  ', '?   ? ', 
     &     '   ?  ', 2*'  ?   ', '      ', '  ?   ', 6*'      ', 
     &     '===== ', 2*' # #  ', '##### ', ' # #  ', '##### ', 
     &     2*' # #  ', ' @@@  ', 2*'    @ ', ' @  @ ', 2*'@ @ @ ', 
     &     ' @@@  ', ' ###  ', '  ##  ', '  #   ', 4*'      ', '"" "" ', 
     &     ' " "  ', 5*'      ', 5*'      ', '===== ', '    = ', 
     &     7*'##### '/
      DATA ckar/7*'      ', '  ##  ', 5*' #  # ', '  ##  ', '  #   ', 
     &     ' ##   ', 4*'  #   ', ' ###  ', ' ###  ', '#   # ', '    # ', 
     &     ' ###  ', 2*'#     ', '##### ', ' ###  ', '#   # ', '    # ', 
     &     '  ##  ', '    # ', '#   # ', ' ###  ', '   #  ', '  ##  ', 
     &     ' # #  ', '#  #  ', '##### ', 2*'   #  ', '##### ', '#     ', 
     &     '####  ', 2*'    # ', '#   # ', ' ###  ', '  ### ', ' #    ', 
     &     '#     ', '####  ', 2*'#   # ', ' ###  ', '##### ', '    # ', 
     &     '   #  ', '  #   ', 3*' #    ', ' ###  ', 2*'#   # ', 
     &     ' ###  ', 2*'#   # ', ' ###  ', ' ###  ', 2*'#   # ', 
     &     ' #### ', '    # ', '   #  ', ' ##   ', '  #   ', ' # #  ', 
     &     2*'#   # ', '##### ', 2*'#   # ', '####  ', 2*' #  # ', 
     &     ' ###  ', 2*' #  # ', '####  ', ' ###  ', '#   # ', 
     &     3*'#     ', '#   # ', ' ###  ', '####  ', 5*' #  # ', 
     &     '####  ', '##### ', 2*'#     ', '###   ', 2*'#     ', 
     &     '##### ', '##### ', 2*'#     ', '###   ', 3*'#     ', 
     &     ' ###  ', '#   # ', 2*'#     ', '# ### ', '#   # ', ' ###  ', 
     &     3*'#   # ', '##### ', 3*'#   # ', ' ###  ', 5*'  #   ', 
     &     ' ###  ', 5*'    # ', '#   # ', ' ###  ', '#   # ', '#  #  ', 
     &     '# #   ', '##    ', '# #   ', '#  #  ', '#   # ', 6*'#     ', 
     &     '##### ', 287*'      '/
      DATA ckar1/'#   # ', '## ## ', '# # # ', 4*'#   # ', '#   # ', 
     &     '##  # ', '# # # ', '#  ## ', 3*'#   # ', '##### ', 
     &     5*'#   # ', '##### ', '####  ', 2*'#   # ', '####  ', 
     &     3*'#     ', ' ###  ', 3*'#   # ', '# # # ', '#  #  ', 
     &     ' ## # ', '####  ', 2*'#   # ', '####  ', '# #   ', '#  #  ', 
     &     '#   # ', ' ###  ', '#   # ', '#     ', ' ###  ', '    # ', 
     &     '#   # ', ' ###  ', '##### ', 6*'  #   ', 6*'#   # ', 
     &     ' ###  ', 5*'#   # ', ' # #  ', '  #   ', 4*'#   # ', 
     &     '# # # ', '## ## ', '#   # ', 2*'#   # ', ' # #  ', '  #   ', 
     &     ' # #  ', 2*'#   # ', 2*'#   # ', ' # #  ', 4*'  #   ', 
     &     '##### ', '    # ', '   #  ', '  #   ', ' #    ', '#     ', 
     &     '##### ', ' ##   ', 2*'#  #  ', ' #    ', '# # # ', '#  #  ', 
     &     ' ## # ', '  #   ', ' #### ', 3*'# #   ', ' #### ', '  #   ', 
     &     5*'      ', 2*' ##   ', 4*'      ', 2*' ##   ', '  #   ', 
     &     '      ', 2*' ##   ', '      ', 2*' ##   ', '      ', 
     &     '    # ', '   ## ', '  ##  ', ' ##   ', '##    ', '#     ', 
     &     '      ', '      ', 2*'  #   ', '##### ', 2*'  #   ', 
     &     '      ', 3*'      ', '##### ', 3*'      ', '  #   ', 
     &     ' #### ', '#     ', ' ###  ', '    # ', '####  ', '  #   '/
      DATA ckar2/2*'      ', '##### ', '      ', '##### ', 2*'      ', 
     &     '# # # ', ' ###  ', '##### ', ' ###  ', '# # # ', 2*'      ', 
     &     7*'  ##  ', 5*'  ##  ', '      ', '  ##  ', '      ', 
     &     2*' ##   ', '      ', 2*' ##   ', '  #   ', '  #   ', 
     &     ' #    ', 3*'#     ', ' #    ', '  #   ', '  #   ', '   #  ', 
     &     3*'    # ', '   #  ', '  #   ', '   #  ', '  #   ', ' #    ', 
     &     '#     ', ' #    ', '  #   ', '   #  ', ' #    ', '  #   ', 
     &     '   #  ', '    # ', '   #  ', '  #   ', ' #    ', 2*'##  # ', 
     &     '   #  ', '  #   ', ' #    ', 2*'#  ## ', ' ###  ', '#   # ', 
     &     '   #  ', 2*'  #   ', '      ', '  #   ', 6*'      ', 
     &     '##### ', 2*' # #  ', '##### ', ' # #  ', '##### ', 
     &     2*' # #  ', ' ###  ', 2*'    # ', ' #  # ', 2*'# # # ', 
     &     ' ###  ', ' ###  ', '  ##  ', '  #   ', 4*'      ', '## ## ', 
     &     ' # #  ', 5*'      ', 5*'      ', '##### ', '    # ', 
     &     7*'##### '/
      DATA ichar/' ', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 
     &     'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 
     &     'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 
     &     'Y', 'Z', '&', '[', '.', ',', ':', '/', '+', '-', '$', '=', 
     &     '*', '!', ']', ';', '(', ')', '<', '>', '%', '?', '_', '#', 
     &     '@', '''', '"', '^', '\\'/
C
C---FROM HERE DOWN TO 6 CHAR1 AND CHAR2, AS WELL AS CKAR1 AND CKAR2
C---ARE PUT INTO THE SAME ARRAY AS CHAR, AND CKAR, RESPECTIVELY.
      ii = 0
      DO 20 i = 24, 46
        ii = ii + 1
        DO 10 j = 1, 7
          char(j,i) = char1(j,ii)
          ckar(j,i) = ckar1(j,ii)
   10   CONTINUE
   20 CONTINUE
      ii = 0
      DO 40 i = 47, 64
        ii = ii + 1
        DO 30 j = 1, 7
          char(j,i) = char2(j,ii)
          ckar(j,i) = ckar2(j,ii)
   30   CONTINUE
   40 CONTINUE
      kk = 0
      k = 1
      DO 60 j = 1, 22
C
C---IF THE CHARACTER TO BE PRINTED IS THE SAME AS THE CHARACTER JUST
C---PRINTED THE SEARCH DOES NOT HAVE TO BE MADE.
        IF (j.GT.1 .AND. INCHAR(j).EQ.INCHAR(j-1)) THEN
          k = kk
        ELSE
C
C---COMPARES ARRAY CHARACTER WITH THE CHARACTER FOR WHICH WE ARE
C---SEARCHING
   50     IF (INCHAR(j).NE.ichar(k)) THEN
            k = k + 1
C
C---IF K EQUALS 64 A SPECIAL CHARACTER IS PRINTED INDICATING THERE WAS
C---A KEY PUNCH ERROR.
            IF (k.NE.64) GOTO 50
          ENDIF
        ENDIF
        IF (ISET.NE.2) THEN
C
C---PUTS ALL 7 PARTS THAT MAKE UP A LARGE CHARACTER INTO ARRAY OUT.
          out(1,j) = char(1,k)
          out(2,j) = char(2,k)
          out(3,j) = char(3,k)
          out(4,j) = char(4,k)
          out(5,j) = char(5,k)
          out(6,j) = char(6,k)
          out(7,j) = char(7,k)
        ELSE
          out(1,j) = ckar(1,k)
          out(2,j) = ckar(2,k)
          out(3,j) = ckar(3,k)
          out(4,j) = ckar(4,k)
          out(5,j) = ckar(5,k)
          out(6,j) = ckar(6,k)
          out(7,j) = ckar(7,k)
        ENDIF
        kk = k
        k = 1
   60 CONTINUE
C
C---PRINTS THE SEVEN PARTS OF EACH LARGE CHARACTER.
      DO 70 i = 1, 7
        WRITE (Iprt,9005) (out(i,k),k=1,22)
   70 CONTINUE
      WRITE (Iprt,'(1X)')
      RETURN
 9005 FORMAT (1X,22A6)
      END
