      SUBROUTINE READXS(NSTA,ZMIN,ZINC,DINC,AINC,WINC,FSLOPE,MANGSN,
     &                  IDENT,LE431,FORM,LUPCS,LUCD,FOUND)
      INCLUDE 'cgdims.cmn'
      INCLUDE 'cgcctl.cmn'
      INCLUDE 'comany.cmn'
      INCLUDE 'comsbd.cmn'
      INTEGER NSTA, LUPCS, LUCD
      REAL ZMIN, ZINC, DINC, AINC, WINC, FSLOPE, MANGSN
      LOGICAL LE431, FOUND
      CHARACTER*60 FORM
      CHARACTER*80 IDENT(MAXCOM)
C
      INTEGER i, ityp, ndsold, ierr
      CHARACTER crd*112
      REAL dmy
C
      DO 10 i = 1, MAXCOM
        IDENT(i) = '    '
   10 CONTINUE
      CALL MOVE0(Subd,MXSUBS)
      CALL MOVE0(Subman,MXSUB1)
C
      ndsold = 0
      FOUND = .FALSE.
C
C CREATE STANDARD FORMAT FILE:  SORT DATA AND ELIMINATE DUPLICATIONS
C
      IF (LE431) THEN
C
C        SET VARIABLES TO THE DEFAULT VALUES
C
        Ncom = 0
        ZMIN = 0.0
        Zmax = 0.0
        Deltaz = 1.0
        Deg = 0.0
        Mn1 = 0
        Mn2 = 0
        Dacorr = 0.0
        ZINC = 0.0
        DINC = 0.0
        Nsubs = 0
        AINC = 0.0
        WINC = 0.0
        FSLOPE = 0.0
        MANGSN = 0.0
   20   READ (LUPCS,'(I1,T1,A80)',ERR=70) i, crd
        IF (crd(:2).EQ.'  ') THEN
          BACKSPACE LUPCS
          GOTO 90
        ENDIF
        IF (i.EQ.3) THEN
          READ (crd,'(2X,I2,10X,I1,1X,I3,9X,I7)') NSTA, ityp, Many, Ndsd
        ELSEIF (i.EQ.5) THEN
          BACKSPACE LUPCS
          READ (LUPCS,9015,ERR=70) (Y(i),H(i),i=1,Many)
          IF ((ityp.EQ.4 .OR. ityp.EQ.3) .AND. Ndsd.EQ.0) Ndsd = ndsold
          ndsold = Ndsd
          IF (ityp.EQ.2) Many = Many - 1
          READ (LUPCS,'(I1)',ERR=70) i
          IF (i.NE.6) BACKSPACE LUPCS
          IF (ityp.NE.3) GOTO 40
        ENDIF
        GOTO 20
      ELSE
        READ (LUPCS,9010,ERR=70,END=60) NSTA, Ncom, ZMIN, Zmax, Deltaz, 
     &                                  Deg, Ndsd, Mn1, Mn2, Dacorr, 
     &                                  ZINC, DINC, Nsubs, AINC, WINC, 
     &                                  FSLOPE, MANGSN
        IF (Ncom.GT.MAXCOM) CALL ERRPRT(37)
        IF (Ncom.GT.0) READ (LUPCS,9020,ERR=70) (IDENT(i),i=1,Ncom)
        IF (Nsubs.NE.0) THEN
          IF (Nsubs.GT.MXSUBS) CALL ERRPRT(10)
          READ (LUPCS,'(A112)') crd
          IF (crd(3:10).EQ.'        ') CALL ERRPRT(2)
          READ (crd,9005) (Subd(i),i=1,MXSUBS), (Subman(i),i=1,MXSUB1)
        ENDIF
        READ (LUCD,FORM,END=60,ERR=70) Y(1), H(1), ityp
        DO 30 i = 2, MAXPTS
          READ (LUCD,FORM,END=50,ERR=70) Y(i), H(i), ityp
          IF (Y(i).EQ.0.0 .AND. H(i).EQ.0.0 .AND. ityp.EQ.0) THEN
            Many = i - 1
            CALL SORTYH(NSTA)
            GOTO 40
          ENDIF
   30   CONTINUE
        GOTO 50
      ENDIF
C
   40 FOUND = .TRUE.
      IF (ZMIN.EQ.0.0 .AND. Zmax.EQ.0.0) THEN
        CALL CMINMX(H,Many,ZMIN,Zmax)
        dmy = (Zmax-ZMIN)*0.10
        Zmax = INT(Zmax-dmy)
        ZMIN = INT(ZMIN+dmy) + 1
      ENDIF
C
C     FINISHED READING INPUT DATA FOR EACH CROSS SECTION.
C
      GOTO 90
   50 ierr = 4
      GOTO 80
   60 ierr = 14
      GOTO 80
   70 ierr = 11
   80 CALL ERRPRT(ierr)
   90 RETURN
 9005 FORMAT (2X,6F8.2,7F8.4)
 9010 FORMAT (I2,2X,I1,3(F7.2),F3.0,I6,1X,2I2,F8.2,2(1X,F6.1),1X,I1,
     &        2(F6.1),4X,F6.4,F6.3)
 9015 FORMAT ((10X,5(F5.0,4X,F5.1)))
 9020 FORMAT (A80)
      END
C
      SUBROUTINE SORTYH(NSTA)
      INTEGER i, im1, k, jm1, j, NSTA
      REAL yh
      LOGICAL sorted, wrte
      INCLUDE 'cgdims.cmn'
      INCLUDE 'comany.cmn'
      INCLUDE 'cgunit.cmn'
      wrte = .FALSE.
   10 k = Many
      sorted = .TRUE.
      DO 30 i = 2, k
        IF (i.GT.Many) GOTO 10
        im1 = i - 1
        yh = Y(i) - Y(im1)
        IF (yh.LE.0.0) THEN
          IF (yh.LT.0.0) THEN
            yh = Y(i)
            Y(i) = Y(im1)
            Y(im1) = yh
            yh = H(i)
            H(i) = H(im1)
            H(im1) = yh
            sorted = .FALSE.
            wrte = .TRUE.
          ELSE
            WRITE (Iprt,9005) Y(im1), H(im1), NSTA
            sorted = .FALSE.
            DO 20 j = i, Many
              jm1 = j - 1
              Y(jm1) = Y(j)
              H(jm1) = H(j)
   20       CONTINUE
            Many = Many - 1
          ENDIF
        ENDIF
   30 CONTINUE
      IF (.NOT.sorted) GOTO 10
      IF (wrte) WRITE (Iprt,9010) NSTA
      RETURN
 9005 FORMAT (' DATA POINT (',F8.1,',',F8.1,') IN CROSS-SECTION #',I2,
     &        ' IS A DUPLICATE AND HAS BEEN IGNORED.')
 9010 FORMAT (' DATA POINTS IN CROSS-SECTION #',I2,
     &        ' WERE OUT OF ORDER AND HAVE BEEN SORTED.')
      END
